stages:
  - test
  - init-app
  - fake-build-app
  - deploy-app


# ---------------- tests immitation
# get-info:
#   stage: test
#   image: "registry.gitlab.com/gitlab-org/cluster-integration/cluster-applications:v1.1.0"
#   environment:
#     name: production
#   script:
#     - kubectl cluster-info
#     - helm version
#     - helm ls
#     - kubectl get namespaces
#     - kubectl get services -A
#     - export INGRESS_IP=$(kubectl get service -n gitlab-managed-apps -o jsonpath=\"{.items[*].status.loadBalancer.ingress[0].ip}\")
#     - echo ${INGRESS_IP}
#     - echo "INGRESS_IP=${INGRESS_IP}" > ingress.env
#   rules:
#     - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
#   artifacts:
#     expire_in: 10 min
#     paths:
#       - "ingress.env"     

## ------ deploy(init) all services 
init-app:
  stage: init-app
  image: "registry.gitlab.com/otus-grad-lab/apps/cluster-management/cluster-applications:v2.0.0"
  environment:
    name: production
  script:
    - printenv | grep CI
    - helm repo add grafana https://grafana.github.io/helm-charts
    - helm repo add prometheus-community https://prometheus-community.github.io/helm-charts
    - helm repo update
    - gl-ensure-namespace gitlab-managed-apps
    - gl-helmfile --file ${CI_PROJECT_DIR}/applications/ingress/helmfile.yaml apply --suppress-secrets
    - while [[ -z "$(kubectl get service -n gitlab-managed-apps -o jsonpath="{.items[*].status.loadBalancer.ingress[0].ip}")" ]]; do sleep 5; done
    - export INGRESS_IP=$(kubectl get service -n gitlab-managed-apps -o jsonpath="{.items[*].status.loadBalancer.ingress[0].ip}")
    - gl-helmfile --file $CI_PROJECT_DIR/helmfile.yaml apply --suppress-secrets
    - echo "=========================== Ingress URLs of frontend ================================="
    - kubectl get ingresses -n applications
    - echo "=========================== Ingress URLs of infra ===================================="
    - kubectl get ingresses -n gitlab-managed-apps
    - echo "======================================================================================"
    - echo $CI_JOB_NAME
  rules:
    - if: '$CI_PIPELINE_SOURCE == "pipeline"'
  # when: manual

  

## --------------------------------------------  

.build_image:
  stage: fake-build-app
  tags:
    - mvp-otus  
  image: "docker:stable"
  when: manual
  script:   
    - echo $CI_REGISTRY_PASSWORD | docker login --username $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    - TAG=$(date +%d%m%Y_%H%M%S)
    - docker pull registry.gitlab.com/otus-grad-lab/apps/cluster-management/${service_name}:v0.0.1
    - docker tag registry.gitlab.com/otus-grad-lab/apps/cluster-management/${service_name}:v0.0.1 registry.gitlab.com/otus-grad-lab/apps/cluster-management/${service_name}:${TAG}
    - echo "image_tag=${TAG}" > ${service_name}.env
    - docker push registry.gitlab.com/otus-grad-lab/apps/cluster-management/${service_name}:${TAG}
    - cat ${service_name}.env
  artifacts:
    expire_in: 30 min
    paths:
      - "*.env"

.deploy_services:
  image: "registry.gitlab.com/otus-grad-lab/apps/cluster-management/cluster-applications:v2.0.0"
  tags:
    - mvp-otus
  stage: deploy-app
  environment:
    name: production    
  when: manual      
  script:
    - source ${service_name}.env
    - >
       if [ "${service_name}" == "frontend" ] || [ "${service_name}" == "loadgenerator" ]; then
         export INGRESS_IP=$(kubectl get service -n gitlab-managed-apps -o jsonpath="{.items[*].status.loadBalancer.ingress[0].ip}")
       fi    
    - gl-helmfile --file ${CI_PROJECT_DIR}/applications/deploy/charts/${service_name}_helmfile.yaml apply --suppress-secrets --set image.tag=${image_tag},image.repository=registry.gitlab.com/otus-grad-lab/apps/cluster-management/${service_name}

## ----------- build services

adservice_build:
  extends: .build_image    
  before_script:
    - export service_name=adservice

cartservice_build:

  extends: .build_image    
  before_script:
    - export service_name=cartservice

checkoutservice_build:
  extends: .build_image    
  before_script:
    - export service_name=checkoutservice    
        
currencyservice_build:
  extends: .build_image    
  before_script:
    - export service_name=currencyservice          

emailservice_build:
  extends: .build_image    
  before_script:
    - export service_name=emailservice 

frontend_build:
  extends: .build_image    
  before_script:
    - export service_name=frontend

loadgenerator_build:
  extends: .build_image    
  before_script:
    - export service_name=loadgenerator   

paymentservice_build:
  extends: .build_image    
  before_script:
    - export service_name=paymentservice  

productcatalogservice_build:
  extends: .build_image    
  before_script:
    - export service_name=productcatalogservice     

recommendationservice_build:
  extends: .build_image    
  before_script:
    - export service_name=recommendationservice

shippingservice_build:
  extends: .build_image    
  before_script:
    - export service_name=shippingservice             


## ----------- deploy services

adservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=adservice
  dependencies:
    - adservice_build 

cartservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=cartservice
  dependencies:
    - cartservice_build 

checkoutservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=checkoutservice 
  dependencies:
    - checkoutservice_build   

currencyservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=currencyservice 
  dependencies:
    - currencyservice_build

emailservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=emailservice 
  dependencies:
    - emailservice_build    

frontend_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=frontend 
  dependencies:
    - frontend_build  

loadgenerator_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=loadgenerator 
  dependencies:
    - loadgenerator_build     

paymentservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=paymentservice 
  dependencies:
    - paymentservice_build     

productcatalogservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=productcatalogservice 
  dependencies:
    - productcatalogservice_build  

recommendationservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=recommendationservice 
  dependencies:
    - recommendationservice_build  

shippingservice_deploy:
  extends: .deploy_services    
  before_script:
    - export service_name=shippingservice 
  dependencies:
    - shippingservice_build             
